<template>
  <el-main>
    <el-row>
      <el-col :sm="{span: 10, offset: 7}" :md="{span: 8, offset: 8}" :lg="{span: 6, offset: 8}">
        <h2>Sign in</h2>
        <el-form ref="form_sign_in" :model="user" label-position="top">
          <el-form-item ref="login" prop="login">
            <el-input v-model="user.login" placeholder="Username"></el-input>
          </el-form-item>

          <el-form-item prop="password">
            <el-input v-model="user.password" type="password" placeholder="Password"></el-input>
          </el-form-item>

          <el-form-item prop="rememberMe">
            <el-switch v-model="user.rememberMe" active-text="Remember me"></el-switch>
          </el-form-item>

          <el-form-item>
            <el-button type="primary" @click="submitForm()">
              Sign in
            </el-button>
          </el-form-item>
        </el-form>
      </el-col>
    </el-row>

    <auth-links current="sign_in"></auth-links>
  </el-main>
</template>

<script>
import gql from 'graphql-tag'
import AuthLinks from '../components/auth_links'

export default {
  components: { 'auth-links': AuthLinks },

  data() { return { user: { login: '', password: '', rememberMe: false } } },
  
  methods: {
    submitForm() {
      this.$apollo.mutate({
        mutation: gql`mutation ($user: SignInInput!) {
          signIn(user: $user) {
            success
            message
          }
        }`,
        variables: {
          user: this.$refs['form_sign_in'].model
        },
        update: (store, { data: { signIn }}) => {
          if(signIn.success)
            window.location.href = '/'
          else
            this.$message.error('Username or password incorrect.')
        }
      })
    }
  }
}
</script>
